diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/model/assert.h ns-3.31/src/core/model/assert.h
--- ns-3.30.1/src/core/model/assert.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/model/assert.h	2020-06-27 17:38:30.000000000 -0700
@@ -59,22 +59,20 @@
  * \ingroup assert
  *
  * At runtime, in debugging builds, if this condition is not
- * true, the program prints the source file, line number and 
+ * true, the program prints the source file, line number and
  * unverified condition and halts by calling std::terminate
  *
  * \param [in] condition Condition to verify.
  */
-#define NS_ASSERT(condition)                                    \
-  do                                                            \
-    {                                                           \
-      if (!(condition))                                         \
-        {                                                       \
-          std::cerr << "assert failed. cond=\"" <<              \
-          # condition << "\", ";                               \
-          NS_FATAL_ERROR_NO_MSG ();                              \
-        }                                                       \
-    }                                                           \
-  while (false)
+#define NS_ASSERT(condition)                          \
+  do {                                                \
+      if (!(condition))                               \
+        {                                             \
+          std::cerr << "assert failed. cond=\""       \
+                    << # condition << "\", ";         \
+          NS_FATAL_ERROR_NO_MSG ();                   \
+        }                                             \
+    }  while (false)
 
 
 /**
@@ -88,32 +86,26 @@
  * \param [in] message Message to output
  */
 #define NS_ASSERT_MSG(condition, message)             \
-  do                                                  \
-    {                                                 \
+  do {                                                \
       if (!(condition))                               \
         {                                             \
           std::cerr << "assert failed. cond=\"" <<    \
-          # condition << "\", ";                     \
+            # condition << "\", ";                    \
           NS_FATAL_ERROR (message);                   \
         }                                             \
-    }                                                 \
-  while (false)
+    } while (false)
 
 #else /* NS3_ASSERT_ENABLE */
 
 #define NS_ASSERT(condition)                          \
-  do                                                  \
-    {                                                 \
+  do {                                                \
       (void)sizeof (condition);                       \
-    }                                                 \
-  while (false)
+    } while (false)
 
 #define NS_ASSERT_MSG(condition, message)             \
-  do                                                  \
-    {                                                 \
+  do {                                                \
       (void)sizeof (condition);                       \
-    }                                                 \
-  while (false)
+    } while (false)
 
 #endif /* NS3_ASSERT_ENABLE */
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/model/attribute-accessor-helper.h ns-3.31/src/core/model/attribute-accessor-helper.h
--- ns-3.30.1/src/core/model/attribute-accessor-helper.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/model/attribute-accessor-helper.h	2020-06-27 17:38:30.000000000 -0700
@@ -31,7 +31,7 @@
 
 namespace ns3 {
 
-  
+
 /**
  * \ingroup attributeimpl
  *
@@ -42,7 +42,7 @@
  * \code
  *   typedef U (T::*getter)(void) const
  * \endcode
- * where \p T is the class and \p U is the type of
+ * where \pname{T} is the class and \pname{U} is the type of
  * the return value.
  *
  * The set method should have one of these signatures:
@@ -50,16 +50,16 @@
  *   typedef void (T::*setter)(U)
  *   typedef bool (T::*setter)(U)
  * \endcode
- * where \p T is the class and \p U is the type of the value to set
+ * where \pname{T} is the class and \pname{U} is the type of the value to set
  * the attribute to, which should be compatible with the
- * specific AttributeValue type \p V which holds the value
+ * specific AttributeValue type \pname{V} which holds the value
  * (or the type implied by the name \c Make<V>Accessor of this function.)
- * In the case of a \p setter returning \p bool, the return value
+ * In the case of a \pname{setter} returning \pname{bool,} the return value
  * should be \c true if the value could be set successfully.
  *
  * \tparam V  \explicit (If present) The specific AttributeValue type
  *            to use to represent the Attribute.  (If not present,
- *            the type \p V is implicit in the name of this function,
+ *            the type \pname{V} is implicit in the name of this function,
  *            as "Make<V>Accessor"
  * \tparam T1 \deduced The type of the class data member,
  *            or the type of the class get functor or set method.
@@ -72,7 +72,7 @@
 Ptr<const AttributeAccessor>
 MakeAccessorHelper (T1 a1);
 
-  
+
 /**
  * \ingroup attributeimpl
  *
@@ -83,7 +83,7 @@
  * \code
  *   typedef U (T::*getter)(void) const
  * \endcode
- * where \p T is the class and \p U is the type of
+ * where \pname{T} is the class and \pname{U} is the type of
  * the return value.
  *
  * The set method should have one of these signatures:
@@ -91,18 +91,18 @@
  *   typedef void (T::*setter)(U)
  *   typedef bool (T::*setter)(U)
  * \endcode
- * where \p T is the class and \p U is the type of the value to set
+ * where \pname{T} is the class and \pname{U} is the type of the value to set
  * the attribute to, which should be compatible with the
- * specific AttributeValue type \p V which holds the value
+ * specific AttributeValue type \pname{V} which holds the value
  * (or the type implied by the name \c Make<V>Accessor of this function.)
- * In the case of a \p setter returning \p bool, the return value
+ * In the case of a \pname{setter} returning \pname{bool,} the return value
  * should be true if the value could be set successfully.
  *
  * In practice the setter and getter arguments can appear in either order,
  * but setter first is preferred.
  *
  * \tparam V  \explicit (If present) The specific AttributeValue type to use to represent
- *            the Attribute.  (If not present, the type \p V is implicit
+ *            the Attribute.  (If not present, the type \pname{V} is implicit
  *            in the name of this function as "Make<V>Accessor"
  * \tparam T1 \deduced The type of the class data member,
  *            or the type of the class get functor or set method.
@@ -118,7 +118,7 @@
 Ptr<const AttributeAccessor>
 MakeAccessorHelper (T1 a1, T2 a2);
 
-  
+
 } // namespace ns3
 
 
@@ -130,11 +130,11 @@
 
 namespace ns3 {
 
-  
+
 /**
  * \ingroup attributeimpl
  *
- * The non-const and non-reference type equivalent to \p T.
+ * The non-const and non-reference type equivalent to \pname{T}.
  *
  * \tparam T \explicit The original (possibly qualified) type.
  */
@@ -145,7 +145,7 @@
   typedef typename TypeTraits<typename TypeTraits<T>::ReferencedType>::NonConstType Result;
 };
 
-  
+
 /**
  * \ingroup attributeimpl
  *
@@ -161,7 +161,8 @@
 {
 public:
   /** Constructor */
-  AccessorHelper () {}
+  AccessorHelper ()
+  {}
 
   /**
    * Set the underlying member to the argument AttributeValue.
@@ -171,11 +172,12 @@
    *
    * Forwards to DoSet method.
    *
-   * \param [in] object Generic object pointer, to upcast to \p T.
-   * \param [in] val Generic AttributeValue, to upcast to \p U.
+   * \param [in] object Generic object pointer, to upcast to \pname{T}.
+   * \param [in] val Generic AttributeValue, to upcast to \pname{U}.
    * \returns true if the member was set successfully.
    */
-  virtual bool Set (ObjectBase * object, const AttributeValue & val) const {
+  virtual bool Set (ObjectBase * object, const AttributeValue & val) const
+  {
     const U *value = dynamic_cast<const U *> (&val);
     if (value == 0)
       {
@@ -197,11 +199,12 @@
    *
    * Forwards to DoGet method.
    *
-   * \param [out] object Generic object pointer, to upcast to \p T.
-   * \param [out] val Generic AttributeValue, to upcast to \p U.
+   * \param [out] object Generic object pointer, to upcast to \pname{T}.
+   * \param [out] val Generic AttributeValue, to upcast to \pname{U}.
    * \returns true if the member value could be retrieved successfully
    */
-  virtual bool Get (const ObjectBase * object, AttributeValue &val) const {
+  virtual bool Get (const ObjectBase * object, AttributeValue &val) const
+  {
     U *value = dynamic_cast<U *> (&val);
     if (value == 0)
       {
@@ -237,7 +240,7 @@
 
 };  // class AccessorHelper
 
-  
+
 /**
  * \ingroup attributeimpl
  *
@@ -258,7 +261,7 @@
   /* AttributeAcessor implementation for a class member variable. */
   class MemberVariable : public AccessorHelper<T,V>
   {
-public:
+  public:
     /*
      * Construct from a class data member address.
      * \param [in] memberVariable The class data member address.
@@ -267,8 +270,10 @@
       : AccessorHelper<T,V> (),
         m_memberVariable (memberVariable)
     {}
-private:
-    virtual bool DoSet (T *object, const V *v) const {
+
+  private:
+    virtual bool DoSet (T *object, const V *v) const
+    {
       typename AccessorTrait<U>::Result tmp;
       bool ok = v->GetAccessor (tmp);
       if (!ok)
@@ -278,14 +283,17 @@
       (object->*m_memberVariable) = tmp;
       return true;
     }
-    virtual bool DoGet (const T *object, V *v) const {
+    virtual bool DoGet (const T *object, V *v) const
+    {
       v->Set (object->*m_memberVariable);
       return true;
     }
-    virtual bool HasGetter (void) const {
+    virtual bool HasGetter (void) const
+    {
       return true;
     }
-    virtual bool HasSetter (void) const {
+    virtual bool HasSetter (void) const
+    {
       return true;
     }
 
@@ -294,7 +302,7 @@
   return Ptr<const AttributeAccessor> (new MemberVariable (memberVariable), false);
 }
 
-  
+
 /**
  * \ingroup attributeimpl
  *
@@ -315,7 +323,7 @@
   /* AttributeAccessor implementation with a class get functor method. */
   class MemberMethod : public AccessorHelper<T,V>
   {
-public:
+  public:
     /*
      * Construct from a class get functor method.
      * \param [in] getter The class get functor method pointer.
@@ -324,20 +332,25 @@
       : AccessorHelper<T,V> (),
         m_getter (getter)
     {}
-private:
-    virtual bool DoSet (T *object, const V *v) const {
+
+  private:
+    virtual bool DoSet (T *object, const V *v) const
+    {
       NS_UNUSED (object);
       NS_UNUSED (v);
       return false;
     }
-    virtual bool DoGet (const T *object, V *v) const {
+    virtual bool DoGet (const T *object, V *v) const
+    {
       v->Set ((object->*m_getter)());
       return true;
     }
-    virtual bool HasGetter (void) const {
+    virtual bool HasGetter (void) const
+    {
       return true;
     }
-    virtual bool HasSetter (void) const {
+    virtual bool HasSetter (void) const
+    {
       return false;
     }
     U (T::*m_getter)(void) const;  // The class get functor method pointer.
@@ -367,7 +380,7 @@
   /* AttributeAccessor implementation with a class set method returning void. */
   class MemberMethod : public AccessorHelper<T,V>
   {
-public:
+  public:
     /*
      * Construct from a class set method.
      * \param [in] setter The class set method pointer.
@@ -376,8 +389,10 @@
       : AccessorHelper<T,V> (),
         m_setter (setter)
     {}
-private:
-    virtual bool DoSet (T *object, const V *v) const {
+
+  private:
+    virtual bool DoSet (T *object, const V *v) const
+    {
       typename AccessorTrait<U>::Result tmp;
       bool ok = v->GetAccessor (tmp);
       if (!ok)
@@ -387,15 +402,18 @@
       (object->*m_setter)(tmp);
       return true;
     }
-    virtual bool DoGet (const T *object, V *v) const {
-      NS_UNUSED(object);
-      NS_UNUSED(v);
+    virtual bool DoGet (const T *object, V *v) const
+    {
+      NS_UNUSED (object);
+      NS_UNUSED (v);
       return false;
     }
-    virtual bool HasGetter (void) const {
+    virtual bool HasGetter (void) const
+    {
       return false;
     }
-    virtual bool HasSetter (void) const {
+    virtual bool HasSetter (void) const
+    {
       return true;
     }
     void (T::*m_setter)(U);  // The class set method pointer, returning void.
@@ -403,12 +421,12 @@
   return Ptr<const AttributeAccessor> (new MemberMethod (setter), false);
 }
 
-  
+
 /**
  * \ingroup attributeimpl
  *
  * MakeAccessorHelper implementation with a class get functor method
- * and a class set method returning \p void.
+ * and a class set method returning \pname{void}.
  *
  * The two versions of this function differ only in argument order.
  *
@@ -433,7 +451,7 @@
    */
   class MemberMethod : public AccessorHelper<T,W>
   {
-public:
+  public:
     /*
      * Construct from class get functor and set methods.
      * \param [in] setter The class set method pointer, returning void.
@@ -445,8 +463,10 @@
         m_setter (setter),
         m_getter (getter)
     {}
-private:
-    virtual bool DoSet (T *object, const W *v) const {
+
+  private:
+    virtual bool DoSet (T *object, const W *v) const
+    {
       typename AccessorTrait<U>::Result tmp;
       bool ok = v->GetAccessor (tmp);
       if (!ok)
@@ -456,14 +476,17 @@
       (object->*m_setter)(tmp);
       return true;
     }
-    virtual bool DoGet (const T *object, W *v) const {
+    virtual bool DoGet (const T *object, W *v) const
+    {
       v->Set ((object->*m_getter)());
       return true;
     }
-    virtual bool HasGetter (void) const {
+    virtual bool HasGetter (void) const
+    {
       return true;
     }
-    virtual bool HasSetter (void) const {
+    virtual bool HasSetter (void) const
+    {
       return true;
     }
     void (T::*m_setter)(U);        // The class set method pointer, returning void.
@@ -472,7 +495,7 @@
   return Ptr<const AttributeAccessor> (new MemberMethod (setter, getter), false);
 }
 
-  
+
 /**
  * \ingroup attributeimpl
  * \copydoc DoMakeAccessorHelperTwo(void(T::*)(U),V(T::*)(void)const)
@@ -486,12 +509,12 @@
   return DoMakeAccessorHelperTwo<W> (setter, getter);
 }
 
-  
+
 /**
  * \ingroup attributeimpl
  *
  * MakeAccessorHelper implementation with a class get functor method
- * and a class set method returning \p bool.
+ * and a class set method returning \pname{bool}.
  *
  * The two versions of this function differ only in argument order.
  *
@@ -516,7 +539,7 @@
    */
   class MemberMethod : public AccessorHelper<T,W>
   {
-public:
+  public:
     /*
      * Construct from class get functor and set method, returning bool.
      * \param [in] setter The class set method pointer, returning bool.
@@ -528,8 +551,10 @@
         m_setter (setter),
         m_getter (getter)
     {}
-private:
-    virtual bool DoSet (T *object, const W *v) const {
+
+  private:
+    virtual bool DoSet (T *object, const W *v) const
+    {
       typename AccessorTrait<U>::Result tmp;
       bool ok = v->GetAccessor (tmp);
       if (!ok)
@@ -539,14 +564,17 @@
       ok = (object->*m_setter)(tmp);
       return ok;
     }
-    virtual bool DoGet (const T *object, W *v) const {
+    virtual bool DoGet (const T *object, W *v) const
+    {
       v->Set ((object->*m_getter)());
       return true;
     }
-    virtual bool HasGetter (void) const {
+    virtual bool HasGetter (void) const
+    {
       return true;
     }
-    virtual bool HasSetter (void) const {
+    virtual bool HasSetter (void) const
+    {
       return true;
     }
     bool (T::*m_setter)(U);        // The class set method pointer, returning bool.
@@ -555,7 +583,7 @@
   return Ptr<const AttributeAccessor> (new MemberMethod (setter, getter), false);
 }
 
-  
+
 /**
  * \ingroup attributeimpl
  * \copydoc ns3::DoMakeAccessorHelperTwo(bool(T::*)(U),V(T::*)(void)const)
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/model/attribute.cc ns-3.31/src/core/model/attribute.cc
--- ns-3.30.1/src/core/model/attribute.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/model/attribute.cc	2020-06-27 17:38:30.000000000 -0700
@@ -35,28 +35,22 @@
 NS_LOG_COMPONENT_DEFINE ("AttributeValue");
 
 AttributeValue::AttributeValue ()
-{
-}
+{}
 AttributeValue::~AttributeValue ()
-{
-}
+{}
 
 
 AttributeAccessor::AttributeAccessor ()
-{
-}
+{}
 AttributeAccessor::~AttributeAccessor ()
-{
-}
+{}
 
 AttributeChecker::AttributeChecker ()
-{
-}
+{}
 AttributeChecker::~AttributeChecker ()
-{
-}
+{}
 
-Ptr<AttributeValue> 
+Ptr<AttributeValue>
 AttributeChecker::CreateValidValue (const AttributeValue &value) const
 {
   NS_LOG_FUNCTION (this << &value);
@@ -109,12 +103,10 @@
 }
 
 EmptyAttributeAccessor::EmptyAttributeAccessor () : AttributeAccessor ()
-{
-}
+{}
 
 EmptyAttributeAccessor::~EmptyAttributeAccessor ()
-{
-}
+{}
 
 bool
 EmptyAttributeAccessor::Set (ObjectBase * object, const AttributeValue &value) const
@@ -145,12 +137,10 @@
 }
 
 EmptyAttributeChecker::EmptyAttributeChecker () : AttributeChecker ()
-{
-}
+{}
 
 EmptyAttributeChecker::~EmptyAttributeChecker ()
-{
-}
+{}
 
 bool
 EmptyAttributeChecker::Check (const AttributeValue &value) const
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/model/attribute.h ns-3.31/src/core/model/attribute.h
--- ns-3.30.1/src/core/model/attribute.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/model/attribute.h	2020-06-27 17:38:30.000000000 -0700
@@ -42,7 +42,7 @@
 /**
  *
  * \ingroup core
- * \defgroup attribute Attributes
+ * \defgroup attributes Attributes
  *
  * The \c ns-3 attribute system is the mechanism used in \c ns-3 to
  * organize, document, and modify the *values* used by the various
@@ -57,12 +57,12 @@
 
 /**
  *
- * \ingroup attribute
+ * \ingroup attributes
  *
  * \brief Hold a value for an Attribute.
  *
  * Instances of this class should always be wrapped into an Attribute object.
- * Most subclasses of this base class are implemented by the 
+ * Most subclasses of this base class are implemented by the
  * ATTRIBUTE_HELPER_* macros.
  */
 class AttributeValue : public SimpleRefCount<AttributeValue>
@@ -104,7 +104,7 @@
 /**
  * \brief allow setting and getting the value of an attribute.
  *
- * \ingroup attribute
+ * \ingroup attributes
  *
  * The goal of this class is to hide from the user how an attribute
  * is actually set or get to or from a class instance. Implementations
@@ -152,7 +152,7 @@
 /**
  * \brief Represent the type of an attribute
  *
- * \ingroup attribute
+ * \ingroup attributes
  *
  * Each type of attribute has an associated unique AttributeChecker
  * subclass. The type of the subclass can be safely used by users
@@ -160,7 +160,7 @@
  * binding authors to use the checker associated to an attribute
  * to detect the type of the associated attribute.
  *
- * Most subclasses of this base class are implemented by the 
+ * Most subclasses of this base class are implemented by the
  * ATTRIBUTE_HELPER_HEADER and ATTRIBUTE_HELPER_CPP macros.
  */
 class AttributeChecker : public SimpleRefCount<AttributeChecker>
@@ -207,7 +207,7 @@
    */
   virtual std::string GetUnderlyingTypeInformation (void) const = 0;
   /**
-   * \returns a new instance of an AttributeValue (wrapper in an Attribute 
+   * \returns a new instance of an AttributeValue (wrapper in an Attribute
    *          instance) which matches the type of the underlying attribute.
    *
    * This method is typically used to create a temporary variable prior
@@ -227,13 +227,14 @@
 /**
  * \brief A class for an empty attribute value.
  *
- * \ingroup attribute
+ * \ingroup attributes
  */
 class EmptyAttributeValue : public AttributeValue
 {
 public:
   /** Default constructor. */
   EmptyAttributeValue ();
+
 private:
   /**
    * \returns a deep copy of this class, wrapped into an Attribute object.
@@ -274,7 +275,7 @@
 };
 
 /**
- * \ingroup attribute
+ * \ingroup attributes
  *
  * \brief Create an empty AttributeAccessor.
  *
@@ -306,7 +307,7 @@
 };
 
 /**
- * \ingroup attribute
+ * \ingroup attributes
  *
  * \brief Create an empty AttributeChecker.
  *
